import { Popover } from "antd"
import React from "react"
import SendEmailTable from "./sendEmailTable"


interface Props {
    data: any
    onChange?: () => void
}
/**
 * 发送Email详细
 * @returns 
 */
const SendEmailDetails: React.FC<Props> = ({ data, onChange }) => {


    return <Popover
        title={<strong>发送邮件记录详情</strong>}
        trigger="click"
        placement="left"
        destroyTooltipOnHide={true}
        zIndex={101}
        content={<div style={{ width: 650 }}>
            <SendEmailTable data={data} />
        </div>}
    >
        <a style={{ fontSize: 12 }}>详情</a>
    </Popover>
}

export default React.memo(SendEmailDetails)